indexing
	description: "Objects that execute features from FRACTIONx classes"
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	FRACTION_TESTER

inherit
	CLASS_TESTER

feature -- Basic operations
	execute_small_suite is
			-- Execute small test suite
		do
			test1 (10)
		end

	execute_medium_suite is
			-- Execute medium test suite
		do
			test1 (30)
			test2 (5)
			test3 (5)
			test4 (5)
			test5 (5)
		end

	execute_large_suite is
			-- Execute large test suite
		do
			test1 (100)
			test2 (100)
			test3 (100)
			test4 (100)
			test5 (100)
		end

feature {NONE} -- Parameters
	bound: INTEGER is 100

feature {NONE} -- Tests
	test1 (count: INTEGER) is
			-- Test 1
		local
			n, d, i: INTEGER
		do
			from
				i := 1
			until
				i > count
			loop
				n := random.bounded_item (-bound, bound)
				random.forth
				d := random.bounded_nonzero_item (-bound, bound)
				create x.make (n, d)
				n := random.bounded_item (-bound, bound)
				random.forth
				d := random.bounded_nonzero_item (-bound, bound)
				create y.make (n, d)
				execute_functions
				i := i + 1
			end
		end

	test2 (count: INTEGER) is
			-- Test 2 (x = 0)
		local
			n, d, i: INTEGER
		do
			from
				i := 1
			until
				i > count
			loop
				d := random.bounded_nonzero_item (-bound, bound)
				create x.make (0, d)
				n := random.bounded_item (-bound, bound)
				random.forth
				d := random.bounded_nonzero_item (-bound, bound)
				create y.make (n, d)
				execute_functions
				i := i + 1
			end
		end

	test3 (count: INTEGER) is
			-- Test 3 (y = 0)
		local
			n, d, i: INTEGER
		do
			from
				i := 1
			until
				i > count
			loop
				n := random.bounded_item (-bound, bound)
				random.forth
				d := random.bounded_nonzero_item (-bound, bound)
				create x.make (n, d)
				d := random.bounded_nonzero_item (-bound, bound)
				create y.make (0, d)
				execute_functions
				i := i + 1
			end
		end

	test4 (count: INTEGER) is
			-- Test 4 (x = y = 0)
		local
			d, i: INTEGER
		do
			from
				i := 1
			until
				i > count
			loop
				d := random.bounded_nonzero_item (-bound, bound)
				create x.make (0, d)
				d := random.bounded_nonzero_item (-bound, bound)
				create y.make (0, d)
				execute_functions
				i := i + 1
			end
		end

	test5 (count: INTEGER) is
			-- Test 5 (x = y)
		local
			n, d, k, i: INTEGER
		do
			from
				i := 1
			until
				i > count
			loop
				n := random.bounded_item (-bound, bound)
				random.forth
				d := random.bounded_nonzero_item (-bound, bound)
				create x.make (n, d)
				k := random.bounded_nonzero_item (-bound, bound)
				create y.make (n*k, d*k)
				execute_functions
				i := i + 1
			end
		end

feature {NONE} -- Implementation
	execute_functions is
			-- Execute functions over `x' and `y'
		local
			b: BOOLEAN
			s: STRING
		do
			z := x.one
			z := x.zero
			b := x.exponentiable (y)
			b := x.is_equal (y)
			z := x + y
			z := x - y
			z := x*y
			if x.divisible (y) then
				z := x/y
			end
			z := -x
			z := +x
			s := x.out
		end

	x, y, z: FRACTION1
--	x, y, z: FRACTION2

end
