indexing
	description: "Objects that execute features from GENEALOGY class"
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	GENEALOGY_TESTER

inherit
	CLASS_TESTER

	DATE_CONSTANTS

feature -- Basic operations
	execute_small_suite is
			-- Execute small test suite
		do
			test1 (10)
		end

	execute_medium_suite is
			-- Execute medium test suite
		do
			test1 (10)
			test2 (10)
			test3 (5)
			test4 (5)
			test5 (20)
		end

	execute_large_suite is
			-- Execute large test suite
		do
			test1 (100)
			test2 (100)
			test3 (50)
			test4 (50)
			test5 (200)
		end

feature {NONE} -- Parameters
	id_bound, id_start: INTEGER

	name_size_bound: INTEGER is 12

	chars: STRING is "abc"

	small_family_count: INTEGER is 4

	big_family_count: INTEGER is 26

feature {NONE} -- Tests
	test1 (count: INTEGER) is
			-- Test 1
		local
			i: INTEGER
		do
			id_start := 0
			id_bound := count
			current_year := 1900
			from i := 1 until i > count loop
				create g.make_empty
				i := i + 1
			end
			from
				i := 1
			until
				i > 2 * count
			loop
				execute_functions
				g.add_male (i, uniform_string (chars, name_size_bound), uniform_string (chars, name_size_bound), random_valid_date)
				g.add_female (i + 1, uniform_string (chars, name_size_bound), uniform_string (chars, name_size_bound), random_valid_date)
				execute_functions
				randomize (i + 1)
				g.register_death (id1, random_valid_date)
				randomize (i + 1)
				g.marry (id1, id2, uniform_string (chars, name_size_bound), uniform_string (chars, name_size_bound), random_valid_date)
				randomize (i + 1)
				g.divorce (id1, uniform_string (chars, name_size_bound), uniform_string (chars, name_size_bound), random_valid_date)
				randomize (i + 1)
				g.register_child (id1, id2)
				randomize (i + 1)
				g.adopt (id1, id2, uniform_string (chars, name_size_bound), random_valid_date)
				i := i + 2
			end
		end

	test2 (count: INTEGER) is
			-- Test 2 (everything after error)
		local
			i: INTEGER
			b: BOOLEAN
			s: STRING
			r: INTEGER
			l: LIST [INTEGER]
			ls: LIST [STRING]
		do
			id_start := 0
			id_bound := count
			current_year := 1900
			create g.make_empty
			g.add_male (1, "John", "Smith", random_valid_date)
			g.register_death (1, random_valid_date)
			from
				i := 2
			until
				i > 2 * count + 1
			loop
				g.register_death (1, random_valid_date)
				g.add_male (i, uniform_string (chars, name_size_bound), uniform_string (chars, name_size_bound), random_valid_date)
				g.register_death (1, random_valid_date)
				g.add_female (i + 1, uniform_string (chars, name_size_bound), uniform_string (chars, name_size_bound), random_valid_date)
				randomize (i + 1)
				g.register_death (1, random_valid_date)
				g.register_death (id1, random_valid_date)
				randomize (i + 1)
				g.register_death (1, random_valid_date)
				g.marry (id1, id2, uniform_string (chars, name_size_bound), uniform_string (chars, name_size_bound), random_valid_date)
				randomize (i + 1)
				g.register_death (1, random_valid_date)
				g.divorce (id1, uniform_string (chars, name_size_bound), uniform_string (chars, name_size_bound), random_valid_date)
				randomize (i + 1)
				g.register_death (1, random_valid_date)
				g.register_child (id1, id2)
				randomize (i + 1)
				g.register_death (1, random_valid_date)
				g.adopt (id1, id2, uniform_string (chars, name_size_bound), random_valid_date)

				id1 := random.bounded_item (-id_bound, id_bound)
				random.forth
				id2 := random.bounded_item (1, id_bound)
				random.forth
				g.register_death (1, random_valid_date)
				if g.has (id1) then
					g.register_death (1, random_valid_date)
					b := g.is_male (id1)
					g.register_death (1, random_valid_date)
					b := g.is_female (id1)
					g.register_death (1, random_valid_date)
					b := g.is_alive (id1)
					g.register_death (1, random_valid_date)
					b := g.is_dead (id1)
					g.register_death (1, random_valid_date)
					s := g.first_name (id1)
					g.register_death (1, random_valid_date)
					s := g.last_name (id1)
					g.register_death (1, random_valid_date)
					s := g.birth_name (id1)
					g.register_death (1, random_valid_date)
					s := g.birth_date (id1)
					g.register_death (1, random_valid_date)
					s := g.death_date (id1)
					g.register_death (1, random_valid_date)
					r := g.father (id1)
					g.register_death (1, random_valid_date)
					r := g.mother (id1)
					g.register_death (1, random_valid_date)
					l := g.parents (id1)
					g.register_death (1, random_valid_date)
					l := g.children (id1)
					g.register_death (1, random_valid_date)
					b := g.is_married (id1)
					g.register_death (1, random_valid_date)
					l := g.partners (id1)
					g.register_death (1, random_valid_date)
					ls := g.marriage_dates (id1)
					g.register_death (1, random_valid_date)
					ls := g.divorce_dates (id1)
					if g.has (id2) then
						g.register_death (1, random_valid_date)
						b := g.is_natural_father (id1, id2)
						g.register_death (1, random_valid_date)
						b := g.is_natural_mother (id1, id2)
						g.register_death (1, random_valid_date)
						b := g.is_parent (id1, id2)
						g.register_death (1, random_valid_date)
						b := g.is_ancestor (id1, id2)
						g.register_death (1, random_valid_date)
						r := g.closest_common_ancestor (id1, id2)
						g.register_death (1, random_valid_date)
						l := g.shortest_relation (id1, id2)
						g.register_death (1, random_valid_date)
						l := g.best_relation (id1, id2)
					end
				end
				g.register_death (1, random_valid_date)
				l := g.find (uniform_string (chars, name_size_bound))
				g.register_death (1, random_valid_date)
				b := g.valid_date (random_date)

				i := i + 2
			end
		end

	test3 (count: INTEGER) is
			-- Test 3 (relations between the same person)
		local
			i: INTEGER
			b: BOOLEAN
			r: INTEGER
			l: LIST [INTEGER]
		do
			id_start := 0
			id_bound := count
			current_year := 1900
			create g.make_empty
			from
				i := 1
			until
				i > count
			loop
				g.add_male (i, uniform_string (chars, name_size_bound), uniform_string (chars, name_size_bound), random_valid_date)
				execute_functions
				g.marry (i, i, uniform_string (chars, name_size_bound), uniform_string (chars, name_size_bound), random_valid_date)
				g.register_child (i, i)
				g.adopt (i, i, uniform_string (chars, name_size_bound), random_valid_date)

				b := g.is_natural_father (i, i)
				b := g.is_natural_mother (i, i)
				b := g.is_parent (i, i)
				b := g.is_ancestor (i, i)
				r := g.closest_common_ancestor (i, i)
				l := g.shortest_relation (i, i)
				l := g.best_relation (i, i)
				i := i + 1
			end
		end

	test4 (count: INTEGER) is
			-- Test 4 (small family + execute functions)
		local
			i: INTEGER
		do
			id_bound := small_family_count
			from
				i := 1
			until
				i > count
			loop
				id_start := random.bounded_item (0, 100)
				random.forth
				create g.make_empty
				g.add_male (id_start + 1, "Victor", "Trunov", "05.07.1957")
				g.add_female (id_start + 2, "Natalia", "Trunova", "21.11.1958")
				g.marry (id_start + 1, id_start + 2, "Trunov", "Trunova", "16.05.1978")
				g.add_male (id_start + 3, "Konstantin", "Trunov", "13.12.1982")
				g.add_female (id_start + 4, "Victoria", "Trunova", "06.06.1986")
				g.register_child (id_start + 1, id_start + 3)
				g.register_child (id_start + 1, id_start + 4)
				g.register_child (id_start + 2, id_start + 3)
				g.register_child (id_start + 2, id_start + 4)
				execute_functions
				i := i + 1
			end
		end

	test5 (count: INTEGER) is
			-- Test 5 (big family + execute functions)
		local
			i: INTEGER
		do
			id_start := 0
			id_bound := big_family_count
			create g.make_empty
			g.add_male (1, "Ivan", "Ivanov", "07.11.1917")
			g.add_male (3, "Petr", "Petrov", "19.05.1920")
			g.add_female (2, "Maria", "Sidorova", "15.10.1920")
			g.add_female (4, "Daria", "Kochkina", "04.04.1922")
			g.add_male (25, "Jakov", "Savelov", "08.09.1922")
			g.add_female (26, "Marina", "Krjukova", "18.12.1924")

			g.marry (1, 2, "Ivanov", "Ivanova", "26.07.1940")
			g.marry (3, 4, "Petrov", "Petrova", "11.09.1946")

			g.add_male (5, "Vladimir", "Ivanov", "30.01.1948")
			g.add_female (7, "Julia", "Petrova", "13.08.1950")
			g.add_male (6, "Nikolay", "Ivanov", "05.06.1952")
			g.add_female (8, "Ekaterina", "Petrova", "08.12.1953")
			g.add_male (10, "Victor", "Sidorov", "15.08.1955")
			g.add_female (11, "Nina", "Alekseeva", "16.08.1955")
			g.add_female (9, "Angelina", "Savelova", "10.11.1956")
			g.register_child (1, 5)
			g.register_child (1, 6)
			g.register_child (2, 5)
			g.register_child (2, 6)
			g.register_child (3, 7)
			g.register_child (3, 8)
			g.register_child (25, 9)
			g.adopt (3, 9, "Petrova", "20.11.1956")
			g.register_child (4, 7)
			g.register_child (4, 8)
			g.register_child (26, 9)
			g.adopt (4, 9, "Petrova", "20.11.1956")

			g.marry (5, 7, "Ivanov", "Ivanova", "17.08.1970")
			g.add_male (12, "Nikolay", "Ivanov", "13.04.1971")
			g.add_female (19, "Ella", "Pirogova", "16.08.1971")
			g.add_female (20, "Liubov", "Demidova", "17.09.1972")
			g.marry (6, 8, "Ivanov", "Ivanova", "04.01.1973")
			g.add_male (13, "Konstantin", "Ivanov", "13.05.1974")
			g.marry (10, 11, "Sidorov", "Sidorova", "08.09.1975")
			g.divorce (10, "Sidorov", "Alekseeva", "10.10.1976")
			g.marry (10, 9, "Sidorov", "Sidorova", "11.10.1976")
			g.add_male (17, "Alexandr", "Dvorkin", "06.07.1978")
			g.adopt (10, 17, "Sidorov", "06.08.1978")
			g.adopt (9, 17, "Sidorov", "06.08.1978")
			g.add_female (21, "Vera", "Dron", "25.09.1978")
			g.add_female (22, "Elvira", "Ermizina", "26.05.1980")
			g.add_male (15, "Vladimir", "Ivanov", "05.06.1981")
			g.add_female (14, "Nadezhda", "Ivanova", "05.05.1982")
			g.add_male (16, "Dmitry", "Ivanov", "10.06.1982")
			g.divorce (5, "Ivanov", "Petrova", "04.01.1983")
			g.divorce (6, "Ivanov", "Petrova", "04.01.1983")
			g.marry (5, 8, "Ivanov", "Ivanova", "05.01.1983")
			g.marry (6, 7, "Ivanov", "Ivanova", "05.01.1983")
			g.adopt (5, 14, "Ivanova", "08.09.1983")
			g.adopt (7, 14, "Ivanova", "08.09.1983")
			g.add_male (18, "Alexey", "Sidorov", "07.09.1985")

			g.register_child (5, 12)
			g.register_child (5, 13)
			g.register_child (7, 12)
			g.register_child (7, 13)
			g.register_child (6, 15)
			g.register_child (6, 16)
			g.register_child (7, 15)
			g.register_child (7, 16)
			g.register_child (9, 18)
			g.register_child (10, 18)

			g.marry (12, 19, "Ivanov", "Ivanova", "17.09.1991")
			g.divorce (12, "Ivanov", "Pirogova", "20.10.1996")
			g.marry (12, 20, "Ivanov", "Ivanova", "31.12.1996")
			g.add_female (24, "Ekaterina", "Ivanova", "10.09.1998")
			g.divorce (12, "Ivanov", "Demidova", "05.09.2000")
			g.marry (12, 21, "Ivanov", "Ivanova", "18.04.2002")
			g.marry (17, 22, "Sidorov", "Sidorova", "19.05.2003")
			g.add_male (23, "Vladimir", "Sidorov", "07.11.2004")


			g.register_child (17, 23)
			g.register_child (22, 23)
			g.register_child (12, 24)
			g.register_child (20, 24)

			from
				i := 1
			until
				i > count
			loop
				execute_functions
				i := i + 1
			end
		end
feature {NONE} -- Implementation
--	g: GENEALOGY1
	g: GENEALOGY2

	id1, id2: INTEGER

	current_year: INTEGER

	randomize (bound: INTEGER) is
			-- Randomize `id1' and `id2'
		do
			id1 := random.bounded_item (1, bound)
			random.forth
			id2 := random.bounded_item (1, bound)
			random.forth
		end

	execute_functions is
			-- Execute functions on `g'
		local
			b: BOOLEAN
			s: STRING
			r: INTEGER
			l: LIST [INTEGER]
			ls: LIST [STRING]
		do
			if not g.last_operation_successful then
				s := g.last_error
			end
			id1 := random.bounded_item (id_start - id_bound, id_start + id_bound)
			random.forth
			id2 := random.bounded_item (id_start + 1, id_start + id_bound)
			random.forth
			if g.has (id1) then
				b := g.is_male (id1)
				b := g.is_female (id1)
				b := g.is_alive (id1)
				b := g.is_dead (id1)
				s := g.first_name (id1)
				s := g.last_name (id1)
				s := g.birth_name (id1)
				s := g.birth_date (id1)
				s := g.death_date (id1)
				r := g.father (id1)
				r := g.mother (id1)
				l := g.parents (id1)
				l := g.children (id1)
				b := g.is_married (id1)
				l := g.partners (id1)
				ls := g.marriage_dates (id1)
				ls := g.divorce_dates (id1)
				if g.has (id2) then
					b := g.is_natural_father (id1, id2)
					b := g.is_natural_mother (id1, id2)
					b := g.is_parent (id1, id2)
					b := g.is_ancestor (id1, id2)
					r := g.closest_common_ancestor (id1, id2)
					l := g.shortest_relation (id1, id2)
					l := g.best_relation (id1, id2)
				end
			end
			l := g.find (uniform_string (chars, name_size_bound))
			b := g.valid_date (random_date)
		end

	random_valid_date: STRING is
			-- Random date after `current_year'
		local
			y, m, d: INTEGER
		do
			y := random.bounded_item (1, 5)
			y := current_year + y
			current_year := y
			random.forth
			m := random.bounded_item (1, months_in_year)
			random.forth
			d := random.bounded_item (1, days_in_i_th_month (m, y))
			random.forth
			Result := (create {DATE}.make (y, m, d)).formatted_out ("[0]dd.[0]mm.yyyy")
		end

	random_date: STRING is
			-- Random date (may be invalid)
		do
			Result := random_valid_date
			if random.decide (0.1) then
				random.forth
				Result.append (uniform_string ("1234567890", 20))
			end
			random.forth
		end
end
