indexing
	description: "Objects that execute features of class MML_DEFAULT_PAIR"
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	MML_DEFAULT_PAIR_TESTER

inherit
	CLASS_TESTER

feature -- Basic operations
	execute_small_suite is
			-- Execute small test suite
		do
			test1 (10)
		end

	execute_medium_suite is
			-- Execute medium test suite
		do
			test1 (40)
			test2 (5)
			test3 (5)
		end

	execute_large_suite is
			-- Execute large test suite
		do
			test1 (400)
			test2 (50)
			test3 (50)
		end

feature {NONE} -- Parameters
	size_bound: INTEGER is 1000

feature {NONE} -- Tests
	test1 (count: INTEGER) is
			-- Test 1 (random items)
	local
		i: INTEGER
		b: BOOLEAN
		s1, s2: STRING
	do
		from
			i := 1
		until
			i > count
		loop
			s1 := random.alpha_string_or_void_item (size_bound)
			random.forth
			s2 := random.alpha_string_or_void_item (size_bound)
			random.forth
			create pair.make_from (s1, s2)
			b := pair.is_identity
			other ?= pair.inversed
			b := pair |=| other
			s1 := pair.out
			i := i + 1
		end
	end

	test2 (count: INTEGER) is
			-- Test 2 (equal items)
	local
		i: INTEGER
		b: BOOLEAN
		s1, s2: STRING
	do
		from
			i := 1
		until
			i > count
		loop
			s1 := random.alpha_string_or_void_item (size_bound)
			random.forth
			if s1 /= Void and random.decide (0.5) then
				create pair.make_from (s1, s1.string)
			else
				create pair.make_from (s1, s1)
			end
			random.forth
			b := pair.is_identity
			other ?= pair.inversed
			if random.decide (0.5) then
				random.forth
				s2 := random.alpha_string_or_void_item (size_bound)
				random.forth
				if s2 /= Void and random.decide (0.5) then
					create other.make_from (s2, s2.string)
				else
					create other.make_from (s2, s2)
				end
			end
			random.forth
			b := pair |=| other
			s1 := pair.out
			i := i + 1
		end
	end

	test3 (count: INTEGER) is
			-- Test 3 (equal pairs)
	local
		i: INTEGER
		b: BOOLEAN
		s1, s2: STRING
	do
		from
			i := 1
		until
			i > count
		loop
			s1 := random.alpha_string_or_void_item (size_bound)
			random.forth
			s2 := random.alpha_string_or_void_item (size_bound)
			random.forth
			create pair.make_from (s1, s2)
			b := pair.is_identity
			other ?= pair.inversed
			if s1 /= Void and s2 /= Void and random.decide (0.5) then
				create other.make_from (s1.string, s2.string)
			else
				create other.make_from (s1, s2)
			end
			b := pair |=| other
			s1 := pair.out
			i := i + 1
		end
	end
feature {NONE} -- Implementation
	pair, other: MML_DEFAULT_PAIR [STRING, STRING]
end
