indexing
	description: "Objects that exersise features of class TRAFFIC_BUILDING"
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	TRAFFIC_BUILDING_TESTER

inherit
	TRAFFIC_TESTER

feature -- Basic operations
	execute_small_suite is
			-- Execute small test suite
		do
			test1 (10)
		end

	execute_medium_suite is
			-- Execute medium test suite
		do
			test1 (20)
			test2 (10)
			test3 (20)
		end

	execute_large_suite is
			-- Execute large test suite
		do
			test1 (200)
			test2 (100)
			test3 (200)
		end

feature {NONE} -- Parameters
	size_bound: DOUBLE

feature {NONE} -- Tests
	test1 (count: INTEGER) is
			-- Test 1
	local
		i: INTEGER
		angle: DOUBLE
		n, f: STRING
	do
		size_bound := 100
		from
			i := 1
		until
			i > count
		loop
			if i \\ 2 = 0 then
				city := random_city (100)
			else
				city := random_city (1)
			end
			randomize_dimentions
			if i \\ 4 = 0 then
				create {TRAFFIC_VILLA} building.make_new (width, depth, height, bounded_random_point (city.center, city.radius))
				building.spotlight
			elseif i \\ 4 = 1 then
				n := random.alpha_string_or_void_item (255)
				f := random.alpha_string_nonempty_item (255)
				create {TRAFFIC_LANDMARK} building.make (bounded_random_point (city.center, city.radius), n, f)
			elseif i \\ 4 = 2 then
				create {TRAFFIC_APARTMENT_BUILDING} building.make_new (width, depth, height, bounded_random_point (city.center, city.radius))
				building.spotlight
			else
				create {TRAFFIC_SKYSCRAPER} building.make_new (width, depth, height, bounded_random_point (city.center, city.radius))
			end
			randomize_dimentions
			building.set_size (width, height, depth)
			building.set_center (bounded_random_point (city.center, city.radius))
			angle := random.bounded_real_item (- 70, 70)
			building.set_angle (angle)
			building.set_description (random.alpha_string_le_item (255))
			execute_functions
			i := i + 1
		end
	end

	test2 (count: INTEGER) is
			-- Test 2 (zero center)
	local
		i: INTEGER
		n, f: STRING
	do
		size_bound := 10
		from
			i := 1
		until
			i > count
		loop
			if i \\ 2 = 0 then
				create city.make (random.alpha_string_nonempty_item (20))
			else
				city := Void
			end
			randomize_dimentions
			if i \\ 4 = 0 then
				create {TRAFFIC_VILLA} building.make_new (width, depth, height, origin)
			elseif i \\ 4 = 1 then
				n := random.alpha_string_or_void_item (255)
				f := random.alpha_string_nonempty_item (255)
				create {TRAFFIC_LANDMARK} building.make (origin, n, f)
			elseif i \\ 4 = 2 then
				create {TRAFFIC_APARTMENT_BUILDING} building.make_new (width, depth, height, origin)
			else
				create {TRAFFIC_SKYSCRAPER} building.make_new (width, depth, height, origin)
			end
			randomize_dimentions
			building.set_size (width, height, depth)
			building.set_center (origin)
			building.set_angle (0.0)
			building.set_description ("")
			execute_functions
			i := i + 1
		end
	end

	test3 (count: INTEGER) is
			-- Test 3 (changed order)
	local
		i: INTEGER
		angle: DOUBLE
		n, f: STRING
	do
		size_bound := 1.0
		from
			i := 1
		until
			i > count
		loop
			if i \\ 2 = 0 then
				city := random_city (100)
			else
				city := random_city (1.0)
			end
			randomize_dimentions
			if i \\ 4 = 0 then
				create {TRAFFIC_VILLA} building.make_new (width, depth, height, bounded_random_point (city.center, city.radius))
			elseif i \\ 4 = 1 then
				n := random.alpha_string_or_void_item (255)
				f := random.alpha_string_nonempty_item (255)
				create {TRAFFIC_LANDMARK} building.make (bounded_random_point (city.center, city.radius), n, f)
				building.spotlight
			elseif i \\ 4 = 2 then
				create {TRAFFIC_APARTMENT_BUILDING} building.make_new (width, depth, height, bounded_random_point (city.center, city.radius))
			else
				create {TRAFFIC_SKYSCRAPER} building.make_new (width, depth, height, bounded_random_point (city.center, city.radius))
				building.spotlight
			end
			execute_functions
			building.set_description (random.alpha_string_le_item (255))
			angle := random.bounded_real_item (- 70, 70)
			building.set_angle (angle)
			randomize_dimentions
			building.set_size (width, height, depth)
			building.set_center (bounded_random_point (city.center, city.radius))
			building.set_angle (angle)
			building.set_description (random.alpha_string_le_item (255))
			i := i + 1
		end
	end
feature {NONE} -- Implementation
	building: TRAFFIC_BUILDING

	width, height, depth: DOUBLE

	randomize_dimentions is
			-- Randomize `width', `height' and `depth'
		do
			width := random.bounded_real_item (0.0, size_bound)
			random.forth
			depth := random.bounded_real_item (0.0, size_bound)
			random.forth
			height := random.bounded_real_item (0.0, size_bound)
			random.forth
		end

	city: TRAFFIC_CITY

	execute_functions is
			-- Execute function on `building' and `city'
		local
			b: BOOLEAN
			p: TRAFFIC_POINT
		do
			b := building.is_insertable (city)
			b := building.is_removable
			p := building.corner_1
			p := building.corner_2
			p := building.corner_3
			p := building.corner_4
			if city /= Void and then city.center /= Void then
				p := bounded_random_point (city.center, city.radius)
			else
				p := origin
			end
			b := building.contains_point (p.x, p.y)
		end

end
