indexing
	description: "Objects that exercise features of class TRAFFIC_ROAD"
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class TRAFFIC_ROAD_TESTER

inherit
	TRAFFIC_TESTER

	TRAFFIC_EVENT_CONTAINER [INTEGER]
		export {NONE} all end

create
	make

feature {NONE} -- Initialization

	make is
			-- Make sure the invariant of TRAFFIC_EVENT_CONTAINER is fulfilled.
		do
			create element_inserted_event
			create element_removed_event
			create id_man
		end


feature -- Basic operations

	execute_small_suite is
			-- Execute small test suite
		do
			test1 (10)
		end

	execute_medium_suite is
			-- Execute medium test suite
		do
			test2 (50)
		end

	execute_large_suite is
			-- Execute large test suite
		do
			test2 (500)
		end

feature {NONE} -- Tests

	size_bound: INTEGER is 255

	test1 (n: INTEGER) is
			-- Random tests
		require
			n_positive: n >= 1
		local
			i,j: INTEGER
			b: BOOLEAN
		do
			from
				i := 1
			until
				i > n
			loop
				create_new_instances

				random.forth
				j := random.item
				if j \\ 2 = 0 then
					type := r1.type
				else
					type := r2.type
				end

				random.forth
				j := random.item
				if j \\ 2 = 0 then
					rs_aux := r1.get_connecting_segment (s1, s2)
				else
					rs_aux := r2.get_connecting_segment (s3, s4)
				end

				random.forth
				j := random.item
				if j \\ 4 = 0 then
					b := r1.connects (s1, s2)
				elseif j \\ 4 = 1 then
					b := r1.connects (s2, s1)
				elseif j \\ 4 = 2 then
					b := r1.connects (s1, s3)
				else
					b := r2.connects (s3, s4)
				end

				create c.make (random.alpha_string_item (10))
				random.forth
				j := random.item
				if j \\ 2 = 0 then
					c.put_station (r1.one_way.start_node.station)
					c.put_station (r1.one_way.end_node.station)
					r1.add_to_city (c)
					r1.remove_from_city
				else
					c.put_station (r2.one_way.start_node.station)
					c.put_station (r2.one_way.end_node.station)
					r2.add_to_city (c)
					r2.remove_from_city
				end

				create_new_instances
				random.forth
				j := random.item
				if j \\ 4 = 0 then
					b := r1.is_insertable (c)
				elseif j \\ 4 = 1 then
					c.put_station (r1.one_way.start_node.station)
					c.put_station (r1.one_way.end_node.station)
					b := r1.is_insertable (c)
				elseif j \\ 4 = 2 then
					b := r2.is_insertable (c)
				else
					c.put_station (r2.one_way.start_node.station)
					c.put_station (r2.one_way.end_node.station)
					b := r2.is_insertable (c)
				end

				create_new_instances
				random.forth
				j := random.item
				if j \\ 4 = 0 then
					b := r1.is_removable
				elseif j \\ 4 = 1 then
					c.put_station (r1.one_way.start_node.station)
					c.put_station (r1.one_way.end_node.station)
					r1.add_to_city (c)
					b := r1.is_removable
				elseif j \\ 4 = 2 then
					b := r2.is_removable
				else
					c.put_station (r2.one_way.start_node.station)
					c.put_station (r2.one_way.end_node.station)
					r2.add_to_city (c)
					b := r2.is_removable
				end

				i := i + 1
			end

		end

	test2 (n: INTEGER) is
			-- Random tests
		require
			n_positive: n >= 1
		local
			i: INTEGER
			b: BOOLEAN
		do
			from
				i := 1
			until
				i > n
			loop
				create_new_instances

				if i \\ 2 = 0 then
					type := r1.type
				else
					type := r2.type
				end

				if i \\ 2 = 0 then
					rs_aux := r1.get_connecting_segment (s1, s2)
				else
					rs_aux := r2.get_connecting_segment (s3, s4)
				end

				if i \\ 4 = 0 then
					b := r1.connects (s1, s2)
				elseif i \\ 4 = 1 then
					b := r1.connects (s2, s1)
				elseif i \\ 4 = 2 then
					b := r1.connects (s1, s3)
				else
					b := r2.connects (s3, s4)
				end

				create c.make (random.alpha_string_item (10))
				if i \\ 2 = 0 then
					c.put_station (r1.one_way.start_node.station)
					c.put_station (r1.one_way.end_node.station)
					r1.add_to_city (c)
					r1.remove_from_city
				else
					c.put_station (r2.one_way.start_node.station)
					c.put_station (r2.one_way.end_node.station)
					r2.add_to_city (c)
					r2.remove_from_city
				end

				create_new_instances
				if i \\ 4 = 0 then
					b := r1.is_insertable (c)
				elseif i \\ 4 = 1 then
					c.put_station (r1.one_way.start_node.station)
					c.put_station (r1.one_way.end_node.station)
					b := r1.is_insertable (c)
				elseif i \\ 4 = 2 then
					b := r2.is_insertable (c)
				else
					c.put_station (r2.one_way.start_node.station)
					c.put_station (r2.one_way.end_node.station)
					b := r2.is_insertable (c)
				end

				create_new_instances
				if i \\ 4 = 0 then
					b := r1.is_removable
				elseif i \\ 4 = 1 then
					c.put_station (r1.one_way.start_node.station)
					c.put_station (r1.one_way.end_node.station)
					r1.add_to_city (c)
					b := r1.is_removable
				elseif i \\ 4 = 2 then
					b := r2.is_removable
				else
					c.put_station (r2.one_way.start_node.station)
					c.put_station (r2.one_way.end_node.station)
					r2.add_to_city (c)
					b := r2.is_removable
				end

				i := i + 1
			end

		end

	create_new_instances is
			-- Create new instances to run tests on.
		do
			create s1.make (random.alpha_string_item (10))
			create s2.make (random.alpha_string_item (10))
			create road_type.make
			id1 := id_man.next_free_index
			create rs1.make (s1.dummy_node, s2.dummy_node, road_type, id1)
			create rs2.make (s2.dummy_node, s1.dummy_node, road_type, id1)
			create r1.make (rs1, rs2)

			create s3.make (random.alpha_string_item (10))
			create s4.make (random.alpha_string_item (10))
			id2 := id_man.next_free_index
			create rs3.make (s3.dummy_node, s4.dummy_node, road_type, id2)
			create r2.make_one_way (rs3)
		end

	r1, r2: TRAFFIC_ROAD
	rs1, rs2, rs3, rs_aux: TRAFFIC_ROAD_SEGMENT
	road_type: TRAFFIC_TYPE_STREET
	s1, s2, s3, s4: TRAFFIC_STATION
	type: TRAFFIC_TYPE_ROAD
	c: TRAFFIC_CITY
	id_man: TRAFFIC_ID_MANAGER
	id1, id2: INTEGER


end
