indexing
	description: "Objects that ..."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class UT_CHARACTER_FORMATTER_TESTER

inherit
	CLASS_TESTER

feature -- Basic operations

	execute_small_suite is
			-- Execute small test suite
		do
			test1 (10)
		end

	execute_medium_suite is
			-- Execute medium test suite
		do
			test2 (5)
		end

	execute_large_suite is
			-- Execute large test suite
		do
			test2 (50)
		end

feature {NONE} -- Tests

	size_bound: INTEGER is 255

	test1 (n: INTEGER) is
			-- Random tests
		local
			i: INTEGER
			c: CHARACTER
			ch_form: UT_CHARACTER_FORMATTER
		do
			from
				i := 1
			until
				i > n
			loop
				c := random.bounded_item (1, size_bound).to_character_8
				random.forth
				create ch_form
				call_all_with_character (c, ch_form)

				i := i + 1
			end
		end

	test2 (n: INTEGER) is
			-- Partition testing + random testing.
		require
			n_positive: n >= 1
		local
			c: CHARACTER
			ch_form: UT_CHARACTER_FORMATTER
			i: INTEGER
		do
			from
				i := 1
			until
				i > n
			loop
				create ch_form
				c := random.bounded_item (40, 126).to_character_8
				call_all_with_character (c, ch_form)
				call_all_with_character ('%B', ch_form)
				call_all_with_character ('%F', ch_form)
				call_all_with_character ('%N', ch_form)
				call_all_with_character ('%R', ch_form)
				call_all_with_character ('%T', ch_form)
				call_all_with_character ('%U', ch_form)
				call_all_with_character ('%%', ch_form)
				call_all_with_character ('%'', ch_form)
				call_all_with_character ('%"', ch_form)
				c := random.bounded_item (127, 199).to_character_8
				call_all_with_character (c, ch_form)

				i := i + 1
			end

		end

	call_all_with_character (c: CHARACTER; ch_form: UT_CHARACTER_FORMATTER) is
			-- Call all routines of UT_CHARACTER_FORMATTER with character `c'.
		require
			ch_form_not_void: ch_form /= Void
		local
			j: INTEGER
			s, rand_s: STRING
			unicode_s: UC_STRING
		do
			s := ch_form.eiffel_character_out (c)
			print (s + "%N")

			s := ch_form.quoted_eiffel_character_out (c)
			print (s + "%N")

			random.forth
			j := random.bounded_item (0, 100)
			rand_s := random_string (j)
			ch_form.append_eiffel_character (rand_s, c)
			print (rand_s + "%N")

			rand_s := random_string (j)
			ch_form.append_quoted_eiffel_character (rand_s, c)
			print (rand_s + "%N")

			rand_s := random_string (j)
			create unicode_s.make_from_string (rand_s)
			ch_form.put_eiffel_character (unicode_s, c)
			print (unicode_s + "%N")

			rand_s := random_string (j)
			create unicode_s.make_from_string (rand_s)
			ch_form.put_quoted_eiffel_character (unicode_s, c)
			print (unicode_s + "%N")
		end


	random_string (n: INTEGER): STRING is
			-- A string composed of `n' random characters (ASCII set)
		require
			n >= 0
		local
			i: INTEGER
		do
			create Result.make_empty
			from
				i := 1
			until
				i > n
			loop
				random.forth
				Result.append_character (random.bounded_item (1, size_bound).to_character_8)
				i := i + 1
			end
		ensure
			result_not_void: Result /= Void
		end

end
