indexing
	description: "Objects that ..."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	UT_VERSION_TESTER

inherit
	CLASS_TESTER

feature -- Basic operations
	execute_small_suite is
			-- Execute small test suite
		do
			set_parameters_real
			test1 (10)
		end

	execute_medium_suite is
			-- Execute medium test suite
		do
			set_parameters_real
			test1 (30)
			set_parameters_small
			test1 (10)
			set_parameters_large
			test1 (10)
		end

	execute_large_suite is
			-- Execute large test suite
		do
			set_parameters_real
			test1 (300)
			set_parameters_small
			test1 (100)
			set_parameters_large
			test1 (100)
		end

feature {NONE} -- Parameters
	max_major: INTEGER

	max_minor: INTEGER

	max_revision: INTEGER

	max_build: INTEGER

	set_parameters_real is
			-- Set parameters to realistic values
		do
			max_major := 20
			max_minor := 10
			max_revision := 100_000
			max_build := 1_000_000
		end

	set_parameters_small is
			-- Set parameters to small values
		do
			max_major := 20
			max_minor := 20
			max_revision := 20
			max_build := 20
		end

	set_parameters_large is
			-- Set parameters to large values
		do
			max_major := 100_000
			max_minor := 100_000
			max_revision := 100_000
			max_build := 100_000
		end
feature {NONE} -- Tests
	test1 (count: INTEGER) is
			-- Test 1
	local
		i, j: INTEGER
		a, b: ARRAY [INTEGER]
	do
		from
			i := 1
		until
			i > count
		loop
			a := random.permutation (4)
			b := random.permutation (4)
			from
				j := 1
			until
				j > 4
			loop
				randomize_numbers
				inspect a [j]
				when 1 then
					create version.make (major, minor, revision, build)
				when 2 then
					create version.make_major (major)
				when 3 then
					create version.make_major_minor (major, minor)
				when 4 then
					create version.make_latest
				end
				randomize_numbers
				inspect b [j]
				when 1 then
					create other.make (major, minor, revision, build)
				when 2 then
					create other.make_major (major)
				when 3 then
					create other.make_major_minor (major, minor)
				when 4 then
					create other.make_latest
				end
				j := j + 1
			end
			execute_functions
			i := i + 1
		end
	end

feature {NONE} -- Implementation
	version, other: UT_VERSION

	major, minor, revision, build: INTEGER

	execute_functions is
			-- Execute functions on `version' and `other'
		local
			res: INTEGER
			s: STRING
			b: BOOLEAN
		do
			if version.has_major then
				res := version.major
			end
			if version.has_minor then
				res := version.minor
			end
			if version.has_revision then
				res := version.revision
			end
			if version.has_build then
				res := version.build
			end
			s := version.out
			b := version < other
		end

	randomize_numbers is
			-- Randomize `major', `minor', `revision' and `build'
		do
			major := random.bounded_item (0, max_major)
			random.forth
			minor := random.bounded_item (0, max_minor)
			random.forth
			revision := random.bounded_item (0, max_revision)
			random.forth
			build := random.bounded_item (0, max_build)
			random.forth
		end
end
